#!/bin/bash
#
# Generate input files for SEM46: mesh_name_list, projection_name_list,
# and sem_name_list, based on templates and models generated by build_
# simple_synthetic_model_*D.py.
#
# Notes:
#
# - You may need to edit the input files manually for parameters other
#   than time and space sampling (e.g. VTK/snapshot outputs, source type,
#   domain decomposition, etc).
#
# - An error may occur in SEM46 projection step if the mesh size is
#   larger than the input model size: this is dealt with by subtracting
#   0.01 mm to the element sizes and rounding them to %.6f. This seems
#   to do the trick but might need some case-dependent tuning.
#
# Francois Lavoue, 24 June 2019
# Last updated FL, 7 Jan 2020

#-- user parameters

dir0="input_files/SEM46_input_files"

dir_ou="$dir0/input_run_simulation_in_simple_synthetic_model_v8a_2-horizontal-layers"

dir_in="$dir0/models/simple_synthetic_model_3D_v8a_2-horizontal-layers"
file_in="$dir_in/build_simple_synthetic_model_3D.in"

dir_templates="$dir0/templates"

# frequencies of interest (in Hz)
fmin=2.5                         # dominant frequency (lowest frequency is too low for being considered)
fmax=$(echo "4*$fmin" | bc -l)   # corresponding max frequency

# simulation parameters
tmax=4.0     # duration (in s)
dt=0.001     # time step (in s, NB: avoid scientific notation for bc)
nsponge=40   # nb of sponge layers (we recommend at least 20)

#-- end user parameters


echo
echo "Make SEM46 inputs in"
echo "  $dir_ou"
echo "from model in"
echo "  $dir_in"
echo

mkdir -p $dir_ou

#-- nb of time steps
#nt=$(echo $(echo "$tmax/$dt" | bc -l) | awk '{printf "%d\n", $0+=$0<0?0:0.9}' | awk '{printf "%i", $1+1}')
nt=$(echo $(echo "$tmax/$dt" | bc -l) | awk '{printf "%i", $1}' | awk '{printf "%i", $1+1}')
echo "nt, dt, tmax = $nt, $dt s, $tmax s"

echo

#-- read domain size from build_simple_synthetic_model_3D.in
zmin=$(awk <$file_in 'NR==2 {print $1}')
zmax=$(awk <$file_in 'NR==2 {print $2}') 
dz=$(awk <$file_in 'NR==2 {print $3}')
xmin=$(awk <$file_in 'NR==3 {print $1}') 
xmax=$(awk <$file_in 'NR==3 {print $2}')
dx=$(awk <$file_in 'NR==3 {print $3}')
ymin=$(awk <$file_in 'NR==4 {print $1}') 
ymax=$(awk <$file_in 'NR==4 {print $2}') 
dy=$(awk <$file_in 'NR==4 {print $3}')

# model width
wx=$(echo "$xmax-($xmin)" | bc -l | awk '{printf "%.3f", $1}')
wy=$(echo "$ymax-($ymin)" | bc -l | awk '{printf "%.3f", $1}')
wz=$(echo "$zmax-($zmin)" | bc -l | awk '{printf "%.3f", $1}')

nz_model=$(echo $(echo "($zmax-($zmin))/$dz" | bc -l) | awk '{printf("%d\n",$0+=$0<0?0:0.9)}' | awk '{printf "%i", $1+1}')
nx_model=$(echo $(echo "($xmax-($xmin))/$dx" | bc -l) | awk '{printf("%d\n",$0+=$0<0?0:0.9)}' | awk '{printf "%i", $1+1}')
ny_model=$(echo $(echo "($ymax-($ymin))/$dy" | bc -l) | awk '{printf("%d\n",$0+=$0<0?0:0.9)}' | awk '{printf "%i", $1+1}')

echo "model wz, wx, wy = $wz, $wx, $wy"
echo "model dz, dx, dy = $dz, $dx, $dy"
echo "model nz, nx, ny = $nz_model, $nx_model, $ny_model"

echo

#-- read min/max velocities from build_simple_synthetic_model_3D.in
# for defining required element size and time step
vmin=9999.   # init.
vmax=0.0

# screen interface properties
il_nint=5
n_int=$(awk <$file_in "NR==$il_nint {print \$1}")
for ((ii=1; ii<=$n_int; ii++)); do
    vp=$(awk <$file_in "NR==$il_nint+$ii {print \$2}")
    vs=$(awk <$file_in "NR==$il_nint+$ii {print \$3}")

    # debug
    #echo "interface nb $ii :   vp = $vp m/s,   vs = $vs m/s"

    if (( $(echo "$vp > $vmax" | bc -l) )) ; then vmax=$vp ; fi
    if (( $(echo "$vs > $vmax" | bc -l) )) ; then vmax=$vs ; fi
    if (( $(echo "$vs > 0" | bc -l) )) ; then
       # consider min Vs (if not 0)
       if (( $(echo "$vs < $vmin" | bc -l) )) ; then vmin=$vs ; fi

       # debug
       #echo "consider min Vs (if not 0)"
       #if (( $(echo "$vs < $vmin" | bc -l) )) ; then vmin=$vs ; echo "vmin = $vmin m/s" ; fi

    else
       # consider min Vp
       if (( $(echo "$vp < $vmin" | bc -l) )) ; then vmin=$vp ; fi

       # debug
       #echo "consider min Vp"   # (debug)
       #if (( $(echo "$vp < $vmin" | bc -l) )) ; then vmin=$vp ; echo "vmin = $vmin m/s" ; fi
    fi
done

il_ngrad=$(( $il_nint+$n_int+1 ))
n_grad=$(awk <$file_in "NR==$il_ngrad {print \$1}")
il_nbump=$(( $il_ngrad+$n_grad+1 ))
n_bump=$(awk <$file_in "NR==$il_nbump {print \$1}")
il_nwave=$(( $il_nbump+$nbump+1 ))
n_wave=$(awk <$file_in "NR==$il_nwave {print \$1}")
il_nano=$(( $il_nwave+$nwave+1 ))
n_ano=$(awk <$file_in "NR==$il_nano {print \$1}")

# screen anomaly properties
for ((ii=1; ii<=$n_ano; ii++)); do
    vp=$(awk <$file_in "NR==$il_nano+2*$ii {print \$1}")
    vs=$(awk <$file_in "NR==$il_nano+2*$ii {print \$2}")

    # debug
    #echo "anomaly nb $ii :   vp = $vp m/s,   vs = $vs m/s"

    if (( $(echo "$vp > $vmax" | bc -l) )) ; then vmax=$vp ; fi
    if (( $(echo "$vs > $vmax" | bc -l) )) ; then vmax=$vs ; fi
    if (( $(echo "$vs > 0" | bc -l) )) ; then
       # consider min Vs
       if (( $(echo "$vs < $vmin" | bc -l) )) ; then vmin=$vs ; fi
    else
       # consider min Vp
       if (( $(echo "$vp < $vmin" | bc -l) )) ; then vmin=$vp ; fi
    fi
done


#-- compute min. wavelength, corresponding max. element size,
# and required time step to satisfy the CFL condition

lambda_min=$(echo "$vmin/$fmax" | bc -l)   # gives the required element size
lambda_max=$(echo "$vmax/$fmin" | bc -l)   # for comparison with model size and PML thickness

echo "$vmax $fmin $lambda_max" | awk '{printf "vmax = %g m/s, fmin = %g Hz, max wavelength = %.2f m.\n", $1, $2, $3}'
echo "$vmin $fmax $lambda_min" | awk '{printf "vmin = %g m/s, fmax = %g Hz, min wavelength = %.2f m.\n", $1, $2, $3}'

echo

# required element size
hmax=$(echo "$lambda_min/1.25" | bc -l)
echo "$hmax" | awk '{printf "h_max = lambda_min / 1.25 = %g m\n", $1}'

# model size (in nb of elements)
nx_el=$(echo "$wx/$hmax" | bc -l | awk '{printf("%d\n",$0+=$0<0?0:0.9)}' | awk '{printf "%i", $1}')
ny_el=$(echo "$wy/$hmax" | bc -l | awk '{printf("%d\n",$0+=$0<0?0:0.9)}' | awk '{printf "%i", $1}')
nz_el=$(echo "$wz/$hmax" | bc -l | awk '{printf("%d\n",$0+=$0<0?0:0.9)}' | awk '{printf "%i", $1}')

# element sizes (in m)
hx=$(echo "$wx/$nx_el" | bc -l | awk '{printf "%.6f", $1-1e-5}')
hy=$(echo "$wy/$ny_el" | bc -l | awk '{printf "%.6f", $1-1e-5}')
hz=$(echo "$wz/$nz_el" | bc -l | awk '{printf "%.6f", $1-1e-5}')
# NB: subtracting 0.01 mm and rounding to %.6f is a trick to end up with
#     a mesh size that is slightly smaller or equal to the input model
#     size, as required in the projection step. This might need some
#     case-dependent tuning.

# recompute model widths with actual element nb and size
wx=$(echo "$hx*$nx_el" | bc -l | awk '{printf "%.3f", $1}')
wy=$(echo "$hy*$ny_el" | bc -l | awk '{printf "%.3f", $1}')
wz=$(echo "$hz*$nz_el" | bc -l | awk '{printf "%.3f", $1}')

# min. element size
hmin=$hx
if (( $(echo "$hy < $hmin" | bc -l) )) ; then hmin=$hy ; fi
if (( $(echo "$hz < $hmin" | bc -l) )) ; then hmin=$hz ; fi

echo

# max. time step (according to eq. 2.10 in SEM46 manual, p. 10)
dt_max=$(echo "0.3*0.17*$hmin/$vmax" | bc -l)
echo "$dt_max" | awk '{printf "dt_max = 0.3*0.17*hmin/vmax = %g s\n", $1}'

# check that input dt is well smaller than dt_max
if (( $(echo "$dt > $dt_max" | bc -l) )); then
   echo $(echo "$dt $dt_max" | awk '{printf "\nError: input dt = %g s is larger than dt_max = %g s.\n", $1, $2}')
   exit
fi

echo

# display parameters to be edited in input files
echo "$wz $nz_el $hz" | awk '{printf "Z-depth = %g m,   nb of z-elements = %i,   hz = %g m\n", $1, $2, $3}'
echo "$wx $nx_el $hx" | awk '{printf "X-width = %g m,   nb of x-elements = %i,   hx = %g m\n", $1, $2, $3}'
echo "$wy $ny_el $hy" | awk '{printf "Y-width = %g m,   nb of y-elements = %i,   hy = %g m\n", $1, $2, $3}'

echo

#exit   # TMP: exit for now (just display the above)

#-- edit SEM46 input files
cat $dir_templates/mesh_input_namelist | \
sed "s/sponge_length=##/sponge_length=$nsponge/g" | \
sed "s/Nb_elementZ=##, Nb_elementX=##, Nb_elementY=##/Nb_elementZ=$nz_el, Nb_elementX=$nx_el, Nb_elementY=$ny_el/g" | \
sed "s/Nb_deformed_element=##, dZ=##, dX=##, dY=##/Nb_deformed_element=$nz_el, dZ=$hz, dX=$hx, dY=$hy/g" | \
sed "s/Nb_point_X=##, Nb_point_Y=##, dX=##, dY=##/Nb_point_X=$nx_model, Nb_point_Y=$ny_model, dX=$dx, dY=$dy/g" | \
cat >$dir_ou/mesh_input_namelist

cat $dir_templates/projection_input_namelist | \
sed "s/Nb_point_Z=##, Nb_point_X=##, Nb_point_Y=##/Nb_point_Z=$nz_model, Nb_point_X=$nx_model, Nb_point_Y=$ny_model/g" | \
sed "s/dZ=##, dX=##, dY=##/dZ=$dz, dX=$dx, dY=$dy/g" | \
cat >$dir_ou/projection_input_namelist

cat $dir_templates/sem_input_namelist | \
sed "s/nb_sample=##/nb_sample=$nt/g" | \
sed "s/dt=##, total_nb_time_step=##/dt=$dt, total_nb_time_step=$nt/g" | \
cat >$dir_ou/sem_input_namelist

#-- check edited lines
grep -e '&MESH_HOMO' -e '&TOPO' $dir_ou/mesh_input_namelist
grep '&REGULAR_GRID' $dir_ou/projection_input_namelist
grep -e '&SOURCE_INFO' -e '&FORWARD_PARAM' $dir_ou/sem_input_namelist

#-- make expected extra_mesh_info file
# (both for comparison with actual extra_mesh_info produced by SEM46 in case of variable mesh size,
# and also because SEM46 will not produce any extra_mesh_info file in case of constant mesh size)
echo "$nz_el $nx_el $ny_el $nz_el" >$dir_ou/extra_mesh_info.in
echo "$dt_max" >>$dir_ou/extra_mesh_info.in

#-- link input files from model dir to run dir with generic file names
suffix_2D=$(echo "          $nx_model $ny_model     $dx $dy" | awk '{printf "_n%ix%i_h%gx%gm",       $1, $2, $3, $4}')
suffix_3D=$(echo "$nz_model $nx_model $ny_model $dz $dx $dy" | awk '{printf "_n%ix%ix%i_h%gx%gx%gm", $1, $2, $3, $4, $5, $6}')
cwd=$(pwd)
cd $dir_ou
   ln -s ../models/$(basename $dir_in)/vp${suffix_3D}.bin    ./vp_cart
   ln -s ../models/$(basename $dir_in)/vs${suffix_3D}.bin    ./vs_cart
   ln -s ../models/$(basename $dir_in)/rho${suffix_3D}.bin   ./rho_cart
   ln -s ../models/$(basename $dir_in)/qp${suffix_3D}.bin    ./qp_cart
   ln -s ../models/$(basename $dir_in)/qs${suffix_3D}.bin    ./qs_cart
   ln -s ../models/$(basename $dir_in)/ztopo${suffix_2D}.bin ./topo
cd $cwd

#-- copy submission scripts (domain decomposition and resource allocation is specific to each case)
cp -p $dir_templates/11_run_meshcreationP4_orthorombic.sh $dir_ou/
cp -p $dir_templates/12_run_projectionP4_orthorombic.sh   $dir_ou/
cp -p $dir_templates/13_run_sem46P4_orthorombic.sh        $dir_ou/

#-- copy build_simple_synthetic_model_*D.in and extend_2D_model_to_3D.in just FYI
cp -p $dir_in/build_simple_synthetic_model_*D.in $dir_ou/
if [ -f $dir_in/extend_2D_model_to_3D.in ]; then
   cp -p $dir_in/extend_2D_model_to_3D.in        $dir_ou/
fi

#-- copy exotic_QC_input_namelist (needed even if not used)
cp -p $dir_templates/exotic_QC_input_namelist $dir_ou/

